# Keeps it night
time set 18000

# Stop recipe toasts
recipe give @a *

# Prevents nether portals from being created
execute as @a at @s run fill ~-1 ~-1 ~-1 ~1 ~2 ~1 air replace nether_portal

# Remove bats and phantoms unless they have the tag spawnAllowed
teleport @e[type=minecraft:bat,tag=!spawnAllowed] ~ -127 ~
teleport @e[type=minecraft:phantom,tag=!spawnAllowed] ~ -127 ~

# Stops zombies and husks from drowning unless they have the tag drownable
execute as @e[type=minecraft:zombie,tag=!drownable] run data merge entity @s {DrownedConversionTime:-1,InWaterTime:-1}
execute as @e[type=minecraft:husk,tag=!drownable] run data merge entity @s {DrownedConversionTime:-1,InWaterTime:-1}

# Stops endermen from being able to grief (without disabling creepers and other mobs) unless they have the tag canGrief
execute as @e[type=minecraft:enderman,tag=!canGrief,tag=!gotBarrier] run data merge entity @s {carriedBlockState:{Name:"minecraft:barrier"},Tags:["gotBarrier"]}
execute as @e[type=minecraft:item,nbt={Item:{id:"minecraft:barrier"}}] run kill @s

# Stops creepers from dropping effect clouds, unless they have the tag lingering
# Credit for the basic idea and help with debugging to Rektar
execute as @e[type=minecraft:creeper,tag=!lingering,tag=!hasEffect] run data merge entity @s {ActiveEffects:[{Id:32b,Amplifier:127b,Duration:20000000,ShowParticles:0b}],Tags:["hasEffect"]}
kill @e[type=minecraft:area_effect_cloud,nbt={Effects:[{Id:32b,Amplifier:127b}]}]

# Spawn Area
execute as @a[tag=!spawn] run tp @s -122 134 -39 facing -121 134 -39
execute as @a[x=-122,y=134,z=-39,distance=..8] run tag @s add spawn

#Keep Inventory
execute if block -135 135 -37 lever[powered=true] run tag @a[tag=!keepinv] add keepinv
execute if block -135 135 -37 lever[powered=false] run tag @a[tag=keepinv] remove keepinv

# Music
scoreboard players add @a[tag=music_boss] musictimer_boss 1
scoreboard players add @a[tag=music_frog] musictimer_frog 1
scoreboard players add @a[tag=music_mine] musictimer_mine 1
scoreboard players add @a[tag=music_space] musictimer_space 1
scoreboard players add @a[tag=music_lib] musictimer_lib 1
execute as @a[scores={musictimer_boss=1}] at @s run playsound minecraft:custom.storytime.boss record @s ~ ~ ~ 1
execute as @a[scores={musictimer_frog=1}] at @s run playsound minecraft:custom.storytime.frog record @s ~ ~ ~ 0.25
execute as @a[scores={musictimer_mine=1}] at @s run playsound minecraft:custom.storytime.mine record @s ~ ~ ~ 0.25
execute as @a[scores={musictimer_space=1}] at @s run playsound minecraft:custom.storytime.space record @s ~ ~ ~ 0.25
execute as @a[scores={musictimer_lib=1}] at @s run playsound minecraft:custom.storytime.lib record @s ~ ~ ~ 0.25
execute as @a[scores={musictimer_boss=142}] run scoreboard players set @s musictimer_boss 0
execute as @a[scores={musictimer_frog=210}] run scoreboard players set @s musictimer_frog 0
execute as @a[scores={musictimer_mine=160}] run scoreboard players set @s musictimer_mine 0
execute as @a[scores={musictimer_space=325}] run scoreboard players set @s musictimer_space 0
execute as @a[scores={musictimer_lib=240}] run scoreboard players set @s musictimer_lib 0

# Travel Books
execute if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{no:1}}} run title @a actionbar {"text":"Doesn't seem like this book has any use here..."}
execute if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:1}}} run tag @a[x=-136,y=77,z=129,distance=..2] add travel
execute if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:2}}} run tag @a[x=-136,y=77,z=129,distance=..2] add travel
execute if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:3}}} run tag @a[x=-136,y=77,z=129,distance=..2] add travel
scoreboard players add @a[tag=travel] timer 1
execute as @e[nbt={Tags:["circle"]}] at @s positioned ~ ~5 ~ if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:1}}} if entity @p[x=-136,y=77,z=129,distance=..10] run function 14er:circle
execute as @e[nbt={Tags:["circle"]}] at @s positioned ~ ~5 ~ if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:2}}} if entity @p[x=-136,y=77,z=129,distance=..10] run function 14er:circle
execute as @e[nbt={Tags:["circle"]}] at @s positioned ~ ~5 ~ if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:3}}} if entity @p[x=-136,y=77,z=129,distance=..10] run function 14er:circle
execute as @e[nbt={Tags:["circle"]}] at @s if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:1}}} if entity @a[x=-136,y=77,z=129,distance=..10] run tp @s ~ ~ ~ ~1.5 ~
execute as @e[nbt={Tags:["circle"]}] at @s if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:2}}} if entity @a[x=-136,y=77,z=129,distance=..10] run tp @s ~ ~ ~ ~1.5 ~
execute as @e[nbt={Tags:["circle"]}] at @s if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:3}}} if entity @a[x=-136,y=77,z=129,distance=..10] run tp @s ~ ~ ~ ~1.5 ~
execute as @a[scores={timer=1}] run tag @s remove music_lib
execute as @a[scores={timer=1}] run scoreboard players set @s musictimer_lib 0
execute as @a[scores={timer=1}] run stopsound @s * minecraft:custom.storytime.lib
execute as @a[scores={timer=30}] run effect give @a[scores={timer=30}] minecraft:blindness 60 1 true
execute as @a[scores={timer=60}] run function 14er:travelparticle
gamemode spectator @a[scores={timer=60}]
execute as @e[type=armor_stand,tag=particle] at @s run particle witch ^ ^-99 ^-1 0 0 0 1 0
execute as @e[type=armor_stand,tag=particle] at @s run particle witch ^ ^-99 ^1 0 0 0 1 0
execute as @e[type=armor_stand,tag=particle] at @s run tp @s ~ ~ ~ ~6 ~
execute as @a[tag=p1] at @s run tp @e[type=armor_stand,tag=particle,tag=p1] ~ ~100 ~
execute as @a[tag=p2] at @s run tp @e[type=armor_stand,tag=particle,tag=p2] ~ ~100 ~
execute as @a[tag=p3] at @s run tp @e[type=armor_stand,tag=particle,tag=p3] ~ ~100 ~
execute as @e[type=snowball,tag=p1] at @s run tp @a[tag=p1] ~ ~-100 ~
execute as @e[type=snowball,tag=p2] at @s run tp @a[tag=p2] ~ ~-100 ~
execute as @e[type=snowball,tag=p3] at @s run tp @a[tag=p3] ~ ~-100 ~
execute at @a[tag=p1,scores={timer=150}] run summon snowball ~ ~100 ~ {Motion:[0.11,0.5,0.0],Tags:["p1"]}
execute at @a[tag=p2,scores={timer=150}] run summon snowball ~ ~100 ~ {Motion:[0.11,0.5,0.0],Tags:["p2"]}
execute at @a[tag=p3,scores={timer=150}] run summon snowball ~ ~100 ~ {Motion:[0.11,0.5,0.0],Tags:["p3"]}
kill @e[type=snowball,x=-136,y=172,z=129,distance=..2]
kill @e[type=snowball,x=-200,y=114.5,z=-113,distance=..2]
kill @e[type=snowball,x=-72,y=282,z=-129,distance=..2]
kill @e[type=snowball,x=506,y=197,z=750,distance=..2]
execute as @a[scores={timer=1..150}] run tp @s -139 77 129 facing -136 76 129
execute if entity @a[scores={timer=180}] as @a at @a run playsound minecraft:block.portal.trigger record @a ~ ~ ~ 1
execute as @a[scores={timer=150..210}] at @s run tp @s ~ ~ ~ facing -136 72 129
execute as @a[scores={timer=211}] run function 14er:travelparticlekill
execute as @a[scores={timer=250}] if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:1}}} run tp @s -200 16 -113 facing -200 17 -118
execute as @a[scores={timer=250}] if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:2}}} run tp @s -72 184 -129 facing -67 185 -129
execute as @a[scores={timer=250}] if block -136 77 129 lectern[has_book=true]{Book:{id:"minecraft:written_book",tag:{book:3}}} run tp @s 506 99 750 facing 511 100 750
execute as @a[scores={timer=280}] run function 14er:enter

# Travel Back
execute as @a[x=500,y=99,z=750,distance=..2] run tag @s add travel2
execute as @a[x=-200,y=16,z=-107,distance=..1] run tag @s add travel2
execute as @a[x=-78,y=184,z=-129,distance=..2] run tag @s add travel2
scoreboard players add @a[tag=travel2] timer2 1
execute as @a[scores={timer2=1}] run tag @s remove music_frog
execute as @a[scores={timer2=1}] run tag @s remove music_mine
execute as @a[scores={timer2=1}] run tag @s remove music_space
execute as @a[scores={timer2=1}] run scoreboard players set @s musictimer_frog 0
execute as @a[scores={timer2=1}] run scoreboard players set @s musictimer_mine 0
execute as @a[scores={timer2=1}] run scoreboard players set @s musictimer_space 0
execute as @a[scores={timer2=1}] run stopsound @s * minecraft:custom.storytime.frog
execute as @a[scores={timer2=1}] run stopsound @s * minecraft:custom.storytime.mine
execute as @a[scores={timer2=1}] run stopsound @s * minecraft:custom.storytime.space
execute as @a[scores={timer2=1}] run effect give @s levitation 3 1 true
execute as @a[scores={timer2=1}] run effect give @s blindness 7 1 true
execute if entity @a[scores={timer2=30}] as @a at @a run playsound minecraft:block.bell.resonate record @a ~ ~ ~ 1
execute as @a[scores={timer2=72}] run function 14er:travelback

# Book Detection
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:128,Item:{id:"minecraft:book",tag:{book:1}}}] unless entity @a[scores={book1true=1}] run function 14er:book1true
execute unless entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:128,Item:{id:"minecraft:book",tag:{book:1}}}] run scoreboard players set @a[scores={book1true=1}] book1true 0
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:129,Item:{id:"minecraft:book",tag:{book:2}}}] unless entity @a[scores={book2true=1}] run function 14er:book2true
execute unless entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:129,Item:{id:"minecraft:book",tag:{book:2}}}] run scoreboard players set @a[scores={book2true=1}] book2true 0
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:130,Item:{id:"minecraft:book",tag:{book:3}}}] unless entity @a[scores={book3true=1}] run function 14er:book3true
execute unless entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:130,Item:{id:"minecraft:book",tag:{book:3}}}] run scoreboard players set @a[scores={book3true=1}] book3true 0

# Wrong Book Detection
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:128,Item:{id:"minecraft:written_book"}}] run title @a actionbar {"text":"That doesn't seem like it belongs there. How about putting it in the lectern?"}
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:129,Item:{id:"minecraft:written_book"}}] run title @a actionbar {"text":"That doesn't seem like it belongs there. How about putting it in the lectern?"}
execute if entity @e[type=minecraft:item_frame,nbt={TileX:-128,TileY:79,TileZ:130,Item:{id:"minecraft:written_book"}}] run title @a actionbar {"text":"That doesn't seem like it belongs there. How about putting it in the lectern?"}

# Map Detection
execute as @a[scores={book1true=1,book2true=1,book3true=1}] run scoreboard players set @a map 1
execute as @a[scores={book1true=0}] run scoreboard players set @a map 0
execute as @a[scores={book2true=0}] run scoreboard players set @a map 0
execute as @a[scores={book3true=0}] run scoreboard players set @a map 0
execute as @a[scores={map=0},nbt={SelectedItem:{id:"minecraft:filled_map"}}] run function 14er:clearmap
execute as @a[scores={map=1},nbt={SelectedItem:{id:"minecraft:filled_map"}}] run function 14er:bonus

# Start
execute if block -136 135 -39 polished_blackstone_button[powered=true] run tag @a[limit=1,tag=!p2,tag=!p3] add p1
execute if block -136 135 -39 polished_blackstone_button[powered=true] run tag @a[limit=1,tag=!p1,tag=!p3] add p2
execute if block -136 135 -39 polished_blackstone_button[powered=true] run tag @a[limit=1,tag=!p1,tag=!p2] add p3
execute if block -136 135 -39 polished_blackstone_button[powered=true] run tag @a[tag=p1] add startmap
scoreboard players add @a[tag=startmap] starttimer 1
execute as @a[scores={starttimer=1}] run gamerule sendCommandFeedback false
execute as @a[scores={starttimer=1}] if entity @a[tag=keepinv] run gamerule keepInventory true
execute as @a[scores={starttimer=1}] run scoreboard players set @a dummylives 5
execute as @a[scores={starttimer=1}] run scoreboard players set @a bossdeath 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a tempspace 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a tempmine 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a book1true 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a book2true 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a book3true 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a timer 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a timer2 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a Lives 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a addlives 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a map 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a bonustimer 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a musictimer_boss 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a musictimer_frog 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a musictimer_lib 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a musictimer_space 0
execute as @a[scores={starttimer=1}] run scoreboard players set @a musictimer_mine 0
execute as @a[scores={starttimer=1}] if block -135 135 -41 lever[powered=false] run tag @a add lives
execute as @a[scores={starttimer=1}] if block -135 135 -41 lever[powered=false] run scoreboard objectives setdisplay list dummylives
execute as @a[scores={starttimer=1}] run spawnpoint @a -144 77 129
execute as @a[scores={starttimer=1}] run team join player @a
execute as @a[scores={starttimer=1}] run summon villager -134 137 129 {Silent:1b,Invulnerable:1b,Team:"player",PersistenceRequired:1b,NoAI:1b,Tags:["p1"],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute as @a[scores={starttimer=1}] run summon villager -136 137 129 {Silent:1b,Invulnerable:1b,Team:"player",PersistenceRequired:1b,NoAI:1b,Tags:["p2"],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute as @a[scores={starttimer=1}] run summon villager -138 137 129 {Silent:1b,Invulnerable:1b,Team:"player",PersistenceRequired:1b,NoAI:1b,Tags:["p3"],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute as @a[scores={starttimer=20}] run effect give @a blindness 999999 1 true
execute as @a[scores={starttimer=60}] run gamemode spectator @a
execute if entity @a[scores={starttimer=60}] as @a at @a run playsound minecraft:music.credits record @a ~ ~ ~ 1
execute as @a[scores={starttimer=60..499}] run tp @a -95 142 55 facing -95 142 58
execute as @a[scores={starttimer=70}] run effect clear @a blindness
execute as @a[scores={starttimer=100}] run title @a title {"text":"The greatest thing..."}
execute as @a[scores={starttimer=200}] run title @a title {"text":"...I ever learned..."}
execute as @a[scores={starttimer=300}] run title @a title {"text":"...was how to rea-"}
execute as @a[scores={starttimer=350}] run title @a clear
execute as @a[scores={starttimer=350}] run stopsound @a record minecraft:music.credits
execute if entity @a[scores={starttimer=350}] as @a at @a run playsound minecraft:entity.enderman.death record @a ~ ~ ~ 0.3
execute as @a[scores={starttimer=351}] run title @a actionbar {"text":"No, no, no, that's not how it goes!"}
execute as @a[scores={starttimer=440..570}] run tp @a -113 139 52 facing -113 137 57
execute as @a[scores={starttimer=450}] run title @a actionbar {"text":"You're a thirty-something year old librarian..."}
execute if entity @a[scores={starttimer=450}] as @a at @a run playsound minecraft:entity.villager.ambient record @a ~ ~ ~ 1
execute as @a[scores={starttimer=510}] run title @a actionbar {"text":"...whose only degree is in Liberal Arts..."}
execute if entity @a[scores={starttimer=510}] as @a at @a run playsound minecraft:entity.villager.ambient record @a ~ ~ ~ 1
execute as @a[scores={starttimer=571..640}] run tp @a -123 139 52 facing -123 137 57
execute as @a[scores={starttimer=580}] run title @a actionbar {"text":"...being forced to work for minimum wage..."}
execute if entity @a[scores={starttimer=580}] as @a at @a run playsound minecraft:entity.villager.ambient record @a ~ ~ ~ 1
execute as @a[scores={starttimer=641..830}] run tp @a -139 143.5 54 facing -139 142 57
execute as @a[scores={starttimer=650..680}] run title @a actionbar {"text":"...and if you don't return THREE OVERDUE BOOKS as soon as possible..."}
execute if entity @a[scores={starttimer=650}] as @a at @a run playsound minecraft:entity.villager.ambient record @a ~ ~ ~ 1
execute as @a[scores={starttimer=740..770}] run title @a actionbar {"text":"...you're gonna get FIRED and quite possibly STARVE TO DEATH!"}
execute if entity @a[scores={starttimer=740}] as @a at @a run playsound minecraft:entity.villager.ambient record @a ~ ~ ~ 1
execute as @a[scores={starttimer=831..950}] run tp @a -95 142 55 facing -95 142 58
execute as @a[scores={starttimer=832}] run title @a subtitle {"text":"presents"}
execute as @a[scores={starttimer=850}] run effect give @a blindness 6 1 true
execute as @a[scores={starttimer=850}] run title @a title {"text":"rovenne"}
execute as @a[scores={starttimer=951..1060}] run tp @a -130 77.1 129 facing -136 77 129
execute as @a[scores={starttimer=960}] run title @a title {"text":"✦ StoryTime ✦","underlined":true,"bold":true,"color":"gold"}
execute if entity @a[scores={starttimer=960}] as @a at @a run playsound minecraft:ui.toast.challenge_complete record @a ~ ~ ~ 1
execute as @a[scores={starttimer=1000}] run summon armor_stand -136 72 129 {Silent:1b,Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,Tags:["circle"]}
execute as @a[scores={starttimer=1060}] run gamemode survival @a
execute as @a[scores={starttimer=1060}] run tag @a add music_lib
execute as @a[scores={starttimer=1061}] run tag @a remove startmap
execute as @a[scores={starttimer=1061}] run scoreboard players set @a starttimer 0

# Ending
scoreboard players add @a[tag=bonus1] bonustimer 1
execute as @a[limit=1,scores={bonustimer=40}] run summon minecraft:firework_rocket -508 157 790 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;16711680,16776960,65280,65535,16755200,16711935]}]}}}}
execute as @a[limit=1,scores={bonustimer=40}] run summon minecraft:firework_rocket -492 157 790 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;16711680,16776960,65280,65535,16755200,16711935]}]}}}}
execute as @a[limit=1,scores={bonustimer=80}] run tellraw @a {"text":"<rovenne> Thank you very much for playing StoryTime!"}
execute as @a[limit=1,scores={bonustimer=200}] run tellraw @a {"text":"<rovenne> I really hope you enjoyed the map!"}
execute as @a[limit=1,scores={bonustimer=300}] run tellraw @a {"text":"<rovenne> You can use the book I gave you to have a look around the map."}
execute as @a[limit=1,scores={bonustimer=400}] run tellraw @a {"text":"<rovenne> Once again, I wanna thank the CTMC Discord for helping me out along the way."}
execute as @a[limit=1,scores={bonustimer=500}] run tellraw @a {"text":"<rovenne> Also, many thanks to the playtesters for giving me feedback."}
execute as @a[limit=1,scores={bonustimer=600}] run tellraw @a {"text":"<rovenne> And if you wanna play more CTM maps by other creators, check out the CTM Repository."}
execute as @a[limit=1,scores={bonustimer=700}] run tellraw @a {"text":"Thank you for playing!","color":"gold","bold":true,"underlined":true}
execute as @a[scores={bonustimer=720}] run tag @a remove bonus1
execute as @a[scores={bonustimer=720}] run scoreboard players set @a bonustimer 0

# Area Unlock
execute if block -153 78 135 redstone_lamp[lit=true] run setblock -153 78 134 air
execute if block -153 78 135 redstone_lamp[lit=true] run fill -154 77 136 -152 81 138 air replace barrier
execute if block -153 78 135 redstone_lamp[lit=true] run fill -154 77 136 -152 81 138 air replace iron_bars
execute if block -153 78 135 redstone_lamp[lit=true] run setblock -153 78 135 air
execute if block -159 78 129 redstone_lamp[lit=true] if entity @a[scores={book1true=1}] run setblock -158 78 129 air
execute if block -159 78 129 redstone_lamp[lit=true] if entity @a[scores={book1true=1}] run fill -161 77 128 -160 81 130 air replace barrier
execute if block -159 78 129 redstone_lamp[lit=true] if entity @a[scores={book1true=1}] run fill -161 77 128 -160 81 130 air replace iron_bars
execute if block -159 78 129 redstone_lamp[lit=true] if entity @a[scores={book1true=1}] run setblock -159 78 129 air
execute if block -159 78 129 redstone_lamp[lit=true] unless entity @a[scores={book1true=1}] run title @a actionbar {"text":"Have you placed the previous objective on the monument yet?","color":"gray"}
execute if block -153 78 123 redstone_lamp[lit=true] if entity @a[scores={book2true=1}] run setblock -153 78 124 air
execute if block -153 78 123 redstone_lamp[lit=true] if entity @a[scores={book2true=1}] run fill -154 77 121 -152 81 122 air replace barrier
execute if block -153 78 123 redstone_lamp[lit=true] if entity @a[scores={book2true=1}] run fill -154 77 121 -152 81 122 air replace iron_bars
execute if block -153 78 123 redstone_lamp[lit=true] if entity @a[scores={book2true=1}] run setblock -153 78 123 air
execute if block -153 78 123 redstone_lamp[lit=true] unless entity @a[scores={book2true=1}] run title @a actionbar {"text":"Have you placed the previous objective on the monument yet?","color":"gray"}

# Mid-Way Spawnpoints
execute positioned -343 37 -243 if block -343 37 -243 minecraft:polished_blackstone_button[powered=true] run spawnpoint @p -342 36 -243 
execute positioned 5 37 -260 if block 5 37 -260 minecraft:polished_blackstone_button[powered=true] run spawnpoint @p 4 36 -261
execute positioned 1265 122 824 if block 1265 122 824 minecraft:polished_blackstone_button[powered=true] run spawnpoint @p 1265 121 821

# Loot Boxes
execute as @e[type=villager,tag=p1] unless entity @s[nbt={ActiveEffects:[{Id:14b}]}] run effect give @s invisibility 1000000 1 true
execute as @e[type=villager,tag=p2] unless entity @s[nbt={ActiveEffects:[{Id:14b}]}] run effect give @s invisibility 1000000 1 true
execute as @e[type=villager,tag=p3] unless entity @s[nbt={ActiveEffects:[{Id:14b}]}] run effect give @s invisibility 1000000 1 true
execute as @a[tag=p1,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:1}}}] at @s run tp @e[type=villager,tag=p1] ~ ~ ~
execute as @a[tag=p2,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:1}}}] at @s run tp @e[type=villager,tag=p2] ~ ~ ~
execute as @a[tag=p3,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:1}}}] at @s run tp @e[type=villager,tag=p3] ~ ~ ~
execute as @a[tag=p1,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:2}}}] at @s run tp @e[type=villager,tag=p1] ~ ~ ~
execute as @a[tag=p2,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:2}}}] at @s run tp @e[type=villager,tag=p2] ~ ~ ~
execute as @a[tag=p3,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:2}}}] at @s run tp @e[type=villager,tag=p3] ~ ~ ~
execute as @a[tag=p1,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:3}}}] at @s run tp @e[type=villager,tag=p1] ~ ~ ~
execute as @a[tag=p2,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:3}}}] at @s run tp @e[type=villager,tag=p2] ~ ~ ~
execute as @a[tag=p3,nbt={SelectedItem:{id:"minecraft:player_head",tag:{lb:3}}}] at @s run tp @e[type=villager,tag=p3] ~ ~ ~
execute as @a[tag=p1,nbt=!{SelectedItem:{id:"minecraft:player_head"}}] at @s unless entity @e[type=villager,tag=p1,x=-134,y=137,z=129,distance=..2] run tp @e[type=villager,tag=p1] -134 137 129
execute as @a[tag=p2,nbt=!{SelectedItem:{id:"minecraft:player_head"}}] at @s unless entity @e[type=villager,tag=p2,x=-136,y=137,z=129,distance=..2] run tp @e[type=villager,tag=p2] -136 137 129
execute as @a[tag=p3,nbt=!{SelectedItem:{id:"minecraft:player_head"}}] at @s unless entity @e[type=villager,tag=p3,x=-138,y=137,z=129,distance=..2] run tp @e[type=villager,tag=p3] -138 137 129

# Lives Counter
execute as @a[tag=lives,scores={Lives=-3}] run scoreboard players set @s dummylives 8
execute as @a[tag=lives,scores={Lives=-2}] run scoreboard players set @s dummylives 7
execute as @a[tag=lives,scores={Lives=-1}] run scoreboard players set @s dummylives 6
execute as @a[tag=lives,scores={Lives=0}] run scoreboard players set @s dummylives 5
execute as @a[tag=lives,scores={Lives=1}] run scoreboard players set @s dummylives 4
execute as @a[tag=lives,scores={Lives=2}] run scoreboard players set @s dummylives 3
execute as @a[tag=lives,scores={Lives=3}] run scoreboard players set @s dummylives 2
execute as @a[tag=lives,scores={Lives=4}] run scoreboard players set @s dummylives 1
execute as @a[tag=lives,scores={Lives=5}] run function 14er:death
execute as @a[tag=lives,nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{lives:1}}}] run tag @s add addlives
execute as @a[tag=lives,tag=addlives,scores={addlives=1}] at @s run function 14er:addlives

# Library Area 3 Button
execute if block -130 63 111 polished_blackstone_button[powered=true] run playsound minecraft:entity.zombie.break_wooden_door record @a ~ ~ ~ 1
execute if block -130 63 111 polished_blackstone_button[powered=true] run fill -135 60 106 -125 61 116 air
execute if block -130 63 111 polished_blackstone_button[powered=true] run setblock -130 62 111 air
execute if block -130 63 111 polished_blackstone_button[powered=true] run setblock -130 63 111 air

# Armor Sets
execute as @p[nbt={Inventory:[{id:"minecraft:leather_helmet",Slot:103b,tag:{lfs:1}},{id:"minecraft:leather_chestplate",Slot:102b,tag:{lfs:2}},{id:"minecraft:leather_leggings",Slot:101b,tag:{lfs:3}},{id:"minecraft:leather_boots",Slot:100b,tag:{lfs:4}}]}] run effect give @s jump_boost 1 2 true
execute as @p[nbt={Inventory:[{id:"minecraft:leather_helmet",Slot:103b,tag:{lfs:1}},{id:"minecraft:leather_chestplate",Slot:102b,tag:{lfs:2}},{id:"minecraft:leather_leggings",Slot:101b,tag:{lfs:3}},{id:"minecraft:leather_boots",Slot:100b,tag:{lfs:4}}]}] run effect give @s haste 1 2 true
execute as @p[nbt={Inventory:[{id:"minecraft:leather_helmet",Slot:103b,tag:{gds:1}},{id:"minecraft:leather_chestplate",Slot:102b,tag:{gds:2}},{id:"minecraft:leather_leggings",Slot:101b,tag:{gds:3}},{id:"minecraft:leather_boots",Slot:100b,tag:{gds:4}}]}] run effect give @s resistance 1 2 true
execute as @p[nbt={Inventory:[{id:"minecraft:chainmail_helmet",Slot:103b,tag:{scs:1}},{id:"minecraft:chainmail_chestplate",Slot:102b,tag:{scs:2}},{id:"minecraft:chainmail_leggings",Slot:101b,tag:{scs:3}},{id:"minecraft:chainmail_boots",Slot:100b,tag:{scs:4}}]}] run effect give @s haste 1 2 true
execute as @p[nbt={Inventory:[{id:"minecraft:chainmail_helmet",Slot:103b,tag:{scs:1}},{id:"minecraft:chainmail_chestplate",Slot:102b,tag:{scs:2}},{id:"minecraft:chainmail_leggings",Slot:101b,tag:{scs:3}},{id:"minecraft:chainmail_boots",Slot:100b,tag:{scs:4}}]}] at @s run effect give @e[type=!player,type=!villager,distance=..3,nbt=!{ActiveEffects:[{Id:19b}]}] poison 5 0 true

# Planet Smash
execute as @a[nbt={SelectedItem:{id:"minecraft:magma_cream",Count:1b,tag:{ps:1}}}] run effect give @s minecraft:jump_boost 1 200 true

# Potions
execute as @a[nbt={ActiveEffects:[{Id:27b,Amplifier:2b,Duration:2380}]}] at @s run summon vex ~ ~1 ~ {Health:8f,LifeTicks:400,Attributes:[{Name:generic.max_health,Base:8},{Name:generic.attack_damage,Base:8}]}
execute as @a[nbt={ActiveEffects:[{Id:27b,Amplifier:2b,Duration:1800}]}] at @s run summon vex ~ ~1 ~ {Health:8f,LifeTicks:400,Attributes:[{Name:generic.max_health,Base:8},{Name:generic.attack_damage,Base:8}]}
execute as @a[nbt={ActiveEffects:[{Id:27b,Amplifier:2b,Duration:1200}]}] at @s run summon vex ~ ~1 ~ {Health:8f,LifeTicks:400,Attributes:[{Name:generic.max_health,Base:8},{Name:generic.attack_damage,Base:8}]}
execute as @a[nbt={ActiveEffects:[{Id:27b,Amplifier:2b,Duration:600}]}] at @s run summon vex ~ ~1 ~ {Health:8f,LifeTicks:400,Attributes:[{Name:generic.max_health,Base:8},{Name:generic.attack_damage,Base:8}]}

# Witch Potion Kill
execute as @e[type=item,nbt={Item:{id:"minecraft:potion",Count:1b}},nbt=!{Item:{tag:{potion:1}}}] run kill @s

# Flower Levitation
execute as @a[x=-341,y=79,z=-248,dx=2,dy=22,dz=2] run effect give @s minecraft:levitation 1 1 true
execute as @a[x=-341,y=79,z=-248,dx=2,dy=22,dz=2] at @s run particle entity_effect ~ ~1 ~ 1.000 0.969 0.000 1 0 normal

# Drop Platform
execute if block -7 183 -271 birch_button[powered=true] run fill -10 182 -271 -12 182 -273 air destroy

# Elevator
execute as @a[x=-35,y=174,z=-262,dx=4,dy=3,dz=4] run tp @s 4 64 -267 facing 4 60 -267
execute as @a[x=4,y=34,z=-267,dy=1] run tp @s -29 183 -260 facing -30 183 -260

# Space Gimmicks
execute as @a[x=325,y=1,z=500,dx=1200,dy=250,dz=550] run effect give @s slow_falling 1 1 true
execute as @a[x=325,y=1,z=500,dx=1200,dy=250,dz=550] run effect give @s jump_boost 1 3 true
execute as @a[x=325,y=1,z=500,dx=940,dy=29,dz=550] run tp @s 534 99 750
execute as @a[x=1266,y=1,z=500,dx=300,dy=29,dz=550] run tp @s 1265 121 821
execute as @e[type=piglin,name="Space Pig",nbt={HandItems:[{id:"minecraft:crossbow",Count:1b,tag:{ChargedProjectiles:[{id:"minecraft:arrow",Count:1b},{},{}],Charged:1b}},{}]}] run replaceitem entity @s weapon.mainhand crossbow{CustomModelData:2,ChargedProjectiles:[{id:"minecraft:firework_rocket",Count:1b,tag:{Fireworks:{Explosions:[{Type:0,Colors:[I;65535]}]}}},{},{}],Charged:1b} 1
execute as @e[type=piglin,name="Space Boss",nbt={HandItems:[{id:"minecraft:crossbow",Count:1b,tag:{ChargedProjectiles:[{id:"minecraft:arrow",Count:1b},{},{}],Charged:1b}},{}]}] run replaceitem entity @s weapon.mainhand crossbow{CustomModelData:2,ChargedProjectiles:[{id:"minecraft:tipped_arrow",Count:1b,tag:{Potion:"minecraft:harming"}},{},{}],Charged:1b} 1

# Space Castle
execute if block 1391 61 803 polished_blackstone_button[powered=true] run tp @p 527 99 750
execute if block 1391 61 803 polished_blackstone_button[powered=true] run setblock 1391 61 803 polished_blackstone_button
execute if block 1391 168 754 polished_blackstone_button[powered=true] run fill 1373 122 803 1409 122 839 redstone_block replace light_blue_wool
execute if block 1391 168 754 polished_blackstone_button[powered=true] run setblock 1391 168 754 air
execute unless block 1391 168 754 polished_blackstone_button[powered=true] unless block 1391 168 753 redstone_lamp[lit=true] run setblock 1391 168 753 redstone_lamp[lit=true]
execute if block 1459 168 821 polished_blackstone_button[powered=true] run fill 1373 122 803 1409 122 839 redstone_block replace cyan_wool
execute if block 1459 168 821 polished_blackstone_button[powered=true] run setblock 1459 168 821 air
execute unless block 1459 168 821 polished_blackstone_button[powered=true] unless block 1460 168 821 redstone_lamp[lit=true] run setblock 1460 168 821 redstone_lamp[lit=true]
execute if block 1391 170 890 polished_blackstone_button[powered=true] run fill 1373 122 803 1409 122 839 redstone_block replace blue_wool
execute if block 1391 170 890 polished_blackstone_button[powered=true] run setblock 1391 170 890 air
execute unless block 1391 170 890 polished_blackstone_button[powered=true] unless block 1391 171 890 redstone_lamp[lit=true] run setblock 1391 171 890 redstone_lamp[lit=true]
execute if block 1373 122 820 redstone_block if block 1373 122 821 redstone_block if block 1373 122 822 redstone_block run fill 1390 121 801 1392 123 803 air
execute if block 1373 122 820 redstone_block if block 1373 122 821 redstone_block if block 1373 122 822 redstone_block run fill 1409 121 820 1411 123 822 air
execute if block 1373 122 820 redstone_block if block 1373 122 821 redstone_block if block 1373 122 822 redstone_block run fill 1390 121 839 1392 123 841 air
execute if block 1373 122 820 redstone_block if block 1373 122 821 redstone_block if block 1373 122 822 redstone_block run fill 1371 121 820 1373 123 822 air

# Kill Armor Stands
execute as @e[type=silverfish,name="aggro"] at @s unless entity @e[type=ghast,distance=..4] run tp @s 0 -100 0
execute as @e[type=armor_stand,name=model] at @s unless entity @e[type=creeper,distance=..1.5] unless entity @e[type=ghast,distance=..4] unless entity @e[type=magma_cube,nbt={Size:3},distance=..2] unless entity @e[type=magma_cube,nbt={Size:1},distance=..1] unless entity @e[type=magma_cube,nbt={Size:0},distance=..1] unless entity @e[type=blaze,distance=..2] unless entity @e[type=phantom,nbt={Size:4},distance=..1] unless entity @e[type=phantom,nbt={Size:32},distance=..4] unless entity @e[type=hoglin,distance=..2] run kill @s

# Frog Boss
scoreboard players add @e[tag=frog] frogtimer 1
kill @e[name="frogboss",type=magma_cube,nbt={Size:1}]
kill @e[name="frogboss",type=magma_cube,nbt={Size:0}]
tp @e[type=magma_cube,name="Frog Prince ½",nbt={Size:0}] 0 -200 0
tp @e[type=magma_cube,name="Frog Prince",nbt={Size:1}] 0 -200 0
fill -413 95 -207 -443 94 -237 air replace fire
execute as @e[tag=frog] run kill @e[type=item,name="Redstone Repeater"]
execute as @e[type=!magma_cube,x=-464,y=80,z=-257,dx=80,dy=10,dz=85] run tp @s -428 94 -222
execute as @e[type=magma_cube,x=-464,y=80,z=-257,dx=80,dy=10,dz=85] run kill @s
execute if block -346 135 -225 minecraft:polished_blackstone_button[powered=true] run summon magma_cube -403 113 -222 {Invulnerable:1b,PersistenceRequired:1b,NoAI:1b,Size:3,Rotation:[90.0F,0F],Tags:["frog"],Passengers:[{id:"minecraft:armor_stand",Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,Rotation:[90.0F,0F],ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:4}}],CustomName:'{"text":"model"}'}],CustomName:'{"text":"frogboss"}',ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute if block -346 135 -225 minecraft:polished_blackstone_button[powered=true] run setblock -346 135 -225 air replace
execute as @e[scores={frogtimer=1}] run spawnpoint @a -428 94 -222
execute as @e[scores={frogtimer=1}] run tag @a remove music_frog
execute as @e[scores={frogtimer=1}] run scoreboard players set @a musictimer_frog 0
execute as @e[scores={frogtimer=1}] run stopsound @a * minecraft:custom.storytime.frog
execute as @e[scores={frogtimer=20}] run effect give @a blindness 4 1 true
execute as @e[scores={frogtimer=20}] run effect give @a slow_falling 12 1 true
execute as @e[scores={frogtimer=35}] run tp @a -428 150 -222 facing -426 150 -222
execute as @e[scores={frogtimer=40}] run tag @a add music_boss
execute as @e[scores={frogtimer=60}] run gamemode adventure @a 
execute as @e[scores={frogtimer=60}] run gamerule keepInventory true
execute as @e[scores={frogtimer=60}] run gamerule mobGriefing false
execute as @e[scores={frogtimer=280}] run fill -457 106 -251 -413 112 -193 sea_lantern replace chiseled_stone_bricks
execute as @e[scores={frogtimer=280}] run fill -457 94 -251 -413 94 -193 sea_lantern replace chiseled_stone_bricks
execute as @e[scores={frogtimer=350}] run function 14er:frogboss
execute as @e[scores={frogtimer=600}] run function 14er:frogboss
execute as @e[scores={frogtimer=700}] run function 14er:frogboss
execute if block -428 106 -240 repeater[powered=true] run tag @e[tag=frog] add frog1
execute if block -428 106 -240 repeater[powered=true] run scoreboard players set @e[tag=frog] frogtimer 1000
execute if block -428 106 -240 repeater[powered=true] run summon firework_rocket -428 106 -238 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:4,Flicker:1b,Colors:[I;16711680]}]}}}}
execute if block -428 106 -240 repeater[powered=true] run fill -429 107 -249 -427 105 -239 air
execute as @e[scores={frogtimer=1100},tag=frog1] run function 14er:frogboss
execute as @e[scores={frogtimer=1400},tag=frog1] run function 14er:frogboss
execute as @e[scores={frogtimer=1700},tag=frog1] run function 14er:frogboss
execute if block -428 106 -204 repeater[powered=true] run tag @e[tag=frog] add frog2
execute if block -428 106 -204 repeater[powered=true] run scoreboard players set @e[tag=frog] frogtimer 2000
execute if block -428 106 -204 repeater[powered=true] run summon firework_rocket -428 106 -206 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:4,Flicker:1b,Colors:[I;16711680]}]}}}}
execute if block -428 106 -204 repeater[powered=true] run fill -429 105 -205 -427 107 -195 air
execute as @e[scores={frogtimer=2100},tag=frog2] run function 14er:frogboss
execute as @e[scores={frogtimer=2700},tag=frog2] run function 14er:frogboss
execute as @e[scores={frogtimer=3300},tag=frog2] run function 14er:frogboss
execute if block -446 106 -222 repeater[powered=true] run tag @e[tag=frog] add frog3
execute if block -446 106 -222 repeater[powered=true] run scoreboard players set @e[tag=frog] frogtimer 3500
execute if block -446 106 -222 repeater[powered=true] run summon firework_rocket -444 106 -222 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:4,Flicker:1b,Colors:[I;16711680]}]}}}}
execute if block -446 106 -222 repeater[powered=true] run tp @e[x=-428,y=94,z=-222,distance=..50,type=!player,type=!item,type=!magma_cube] 0 -200 0
execute if block -446 106 -222 repeater[powered=true] run tp @e[x=-428,y=94,z=-222,distance=..50,type=magma_cube,nbt=!{Size:3}] 0 -200 0
execute if block -446 106 -222 repeater[powered=true] run tp @e[tag=frog] -408 176 -257
execute if block -446 106 -222 repeater[powered=true] run fill -445 105 -223 -455 107 -221 air
execute as @e[scores={frogtimer=3600},tag=frog3] run summon magma_cube -428 100 -222 {CustomNameVisible:0b,DeathLootTable:"minecraft:empty",PersistenceRequired:1b,AbsorptionAmount:40f,Size:3,Passengers:[{id:"minecraft:armor_stand",CustomNameVisible:0b,Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:4}}],CustomName:'{"text":"model"}'}],CustomName:'{"text":"Frog Prince","color":"gold","bold":true,"underlined":true}',ActiveEffects:[{Id:1b,Amplifier:1b,Duration:1999980,ShowParticles:0b},{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.knockback_resistance,Base:1.0},{Id:22b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute as @e[scores={frogtimer=3700..},tag=frog3] unless entity @e[x=-428,y=94,z=-222,distance=..50,type=magma_cube] run tag @e[tag=frog] add frog4
execute as @e[scores={frogtimer=3700..},tag=frog3] if entity @e[x=-428,y=94,z=-222,distance=..50,type=magma_cube] run scoreboard players set @e[tag=frog] frogtimer 3800
execute as @e[scores={frogtimer=3820},tag=frog4] run tag @a remove music_boss
execute as @e[scores={frogtimer=3820},tag=frog4] run scoreboard players set @a musictimer_boss 0
execute as @e[scores={frogtimer=3820},tag=frog4] run stopsound @a * minecraft:custom.storytime.boss
execute as @e[scores={frogtimer=3900},tag=frog4] run function 14er:frogboss
execute as @e[scores={frogtimer=3960},tag=frog4] run function 14er:frogboss
execute as @e[scores={frogtimer=3961},tag=frog4] run kill @e[tag=frog]
execute as @e[tag=frog] run effect give @e[scores={bossdeath=1}] weakness 10 1 true
execute as @e[tag=frog] run effect give @e[scores={bossdeath=1}] slowness 10 1 true
execute as @e[tag=frog] run scoreboard players set @e[scores={bossdeath=1},nbt={ActiveEffects:[{Id:2b}]},nbt={ActiveEffects:[{Id:18b}]}] bossdeath 0

# Mine Boss
execute as @e[type=illusioner,tag=!mine] at @s run particle smoke ~ ~ ~ 0 0 0 0 5 force
scoreboard players add @e[tag=mine] minetimer 1
scoreboard players add @e[tag=tempmine] tempmine 1
execute if block 57 43 -135 minecraft:polished_blackstone_button[powered=true] run tag @a[limit=1] add tempmine
execute if block 57 43 -135 minecraft:polished_blackstone_button[powered=true] run setblock 57 43 -135 air replace
fill 11 74 -367 32 81 -346 air replace fire
execute as @e[x=-14,y=60,z=-397,dx=80,dy=10,dz=80,type=blaze] run tp @s 0 -200 0
execute if entity @e[tag=mine] as @e[type=armor_stand,tag=fb] at @s run tp @s ~ ~ ~ facing entity @p eyes
execute as @e[scores={tempmine=1}] run spawnpoint @a 21 81 -356
execute as @e[scores={tempmine=1}] run tag @a remove music_mine
execute as @e[scores={tempmine=1}] run scoreboard players set @a musictimer_mine 0
execute as @e[scores={tempmine=1}] run stopsound @a * minecraft:custom.storytime.mine
execute as @e[scores={tempmine=20}] run effect give @a blindness 4 1 true
execute as @e[scores={tempmine=20}] run effect give @a slow_falling 9 1 true
execute as @e[scores={tempmine=35}] run tp @a 21 120 -356 facing 20 120 -356
execute as @e[scores={tempmine=40}] run tag @a add music_boss
execute as @e[scores={tempmine=60}] run summon illusioner 4 82 -356 {Silent:1b,Invulnerable:1b,PersistenceRequired:1b,NoAI:1b,Rotation:[-90.0F,0F],Tags:["mine"],ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:10}}]}
execute as @e[scores={tempmine=70}] run scoreboard players set @e[tag=mine] minetimer 60
execute as @e[scores={tempmine=80}] run tag @a remove tempmine
execute as @e[scores={tempmine=80}] run scoreboard players set @a tempmine 0
execute as @e[scores={minetimer=60}] run gamemode adventure @a 
execute as @e[scores={minetimer=60}] run gamerule keepInventory true
execute as @e[scores={minetimer=60}] run gamerule mobGriefing false
execute as @e[scores={minetimer=100}] run tellraw @a {"text":"Fireballs will be shot at you from the sides.","color":"gray"}
execute as @e[scores={minetimer=200}] run tellraw @a {"text":"Knock these towards the targets to progress.","color":"gray"}
execute as @e[scores={minetimer=240}] run fill 7 82 -354 7 82 -358 blue_stained_glass
execute if entity @e[scores={minetimer=240}] as @a at @a run playsound minecraft:block.piston.contract record @a ~ ~ ~ 1
execute as @e[scores={minetimer=250}] run fill 7 83 -354 7 83 -358 blue_stained_glass
execute if entity @e[scores={minetimer=250}] as @a at @a run playsound minecraft:block.piston.contract record @a ~ ~ ~ 1
execute as @e[scores={minetimer=260}] run fill 7 84 -354 7 84 -358 blue_stained_glass
execute if entity @e[scores={minetimer=260}] as @a at @a run playsound minecraft:block.piston.contract record @a ~ ~ ~ 1
execute as @e[scores={minetimer=270}] run fill 7 85 -354 7 85 -358 blue_stained_glass
execute if entity @e[scores={minetimer=270}] as @a at @a run playsound minecraft:block.piston.contract record @a ~ ~ ~ 1
execute as @e[scores={minetimer=280}] run fill 7 86 -354 7 86 -358 blue_stained_glass
execute if entity @e[scores={minetimer=280}] as @a at @a run playsound minecraft:block.piston.contract record @a ~ ~ ~ 1
execute as @e[scores={minetimer=281}] run summon armor_stand 21 82 -342 {Silent:1b,Invulnerable:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,Tags:["fb"],DisabledSlots:4144959}
execute as @e[scores={minetimer=281}] run summon armor_stand 21 82 -370 {Silent:1b,Invulnerable:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,Tags:["fb"],DisabledSlots:4144959}
execute as @e[scores={minetimer=282}] run tag @e[tag=mine] add part1
execute as @e[tag=part1,scores={minetimer=300}] run summon pillager 31 76 -346 {Motion:[-0.6,1.2,-0.6],CustomNameVisible:0b,DeathLootTable:"14er:entities/lbtier2",Health:12f,CustomName:'{"text":"Cowboy","color":"#FFBB00","bold":true}',HandItems:[{id:"minecraft:crossbow",Count:1b,tag:{Unbreakable:1b,CustomModelData:1,Enchantments:[{id:"minecraft:quick_charge",lvl:1s}]}},{}],HandDropChances:[-327.670F,0.085F],ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:7}}],ArmorDropChances:[0.085F,0.085F,0.085F,-327.670F],ActiveEffects:[{Id:1b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.max_health,Base:12}]}
execute as @e[tag=part1,scores={minetimer=300}] run summon pillager 31 76 -366 {Motion:[-0.6,1.2,0.6],CustomNameVisible:0b,DeathLootTable:"14er:entities/lbtier2",Health:12f,CustomName:'{"text":"Cowboy","color":"#FFBB00","bold":true}',HandItems:[{id:"minecraft:crossbow",Count:1b,tag:{Unbreakable:1b,CustomModelData:1,Enchantments:[{id:"minecraft:quick_charge",lvl:1s}]}},{}],HandDropChances:[-327.670F,0.085F],ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:7}}],ArmorDropChances:[0.085F,0.085F,0.085F,-327.670F],ActiveEffects:[{Id:1b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.max_health,Base:12}]}
execute if entity @e[tag=part1,scores={minetimer=560}] as @e[type=armor_stand,tag=fb] at @s run function 14er:fireshot
execute as @e[tag=part1,scores={minetimer=660}] run summon blaze 13 75 -348 {Motion:[0.0,1.75,0.0],CustomNameVisible:1b,DeathLootTable:"14er:entities/lbtier2",Health:12f,Passengers:[{id:"minecraft:armor_stand",CustomNameVisible:0b,Invulnerable:1b,Small:0b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,ArmorItems:[{},{},{},{id:'minecraft:apple',Count:1b,tag:{CustomModelData:9}}],CustomName:'{"text":"model"}'}],CustomName:'{"text":"Crystal Critter","color":"blue","bold":true}',ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.max_health,Base:12}]}
execute as @e[tag=part1,scores={minetimer=660}] run summon blaze 13 75 -364 {Motion:[0.0,1.75,0.0],CustomNameVisible:1b,DeathLootTable:"14er:entities/lbtier2",Health:12f,Passengers:[{id:"minecraft:armor_stand",CustomNameVisible:0b,Invulnerable:1b,Small:0b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,ArmorItems:[{},{},{},{id:'minecraft:apple',Count:1b,tag:{CustomModelData:9}}],CustomName:'{"text":"model"}'}],CustomName:'{"text":"Crystal Critter","color":"blue","bold":true}',ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.max_health,Base:12}]}
execute if entity @e[tag=part1,scores={minetimer=900}] as @e[type=armor_stand,tag=fb] at @s run function 14er:fireshot
execute as @e[tag=part1,scores={minetimer=960}] run scoreboard players set @s minetimer 299
execute if block 21 88 -340 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-340,distance=..3] run tag @e[tag=mine,tag=part1] add target1
execute if block 21 88 -340 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-340,distance=..3] run summon creeper 21 88 -340 {powered:1b,Fuse:0,ignited:1b}
execute if block 21 88 -340 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-340,distance=..3] run fill 20 87 -341 22 89 -339 air
execute if block 9 87 -342 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-342,distance=..3] run tag @e[tag=mine,tag=part1] add target2
execute if block 9 87 -342 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-342,distance=..3] run summon creeper 9 87 -342 {powered:1b,Fuse:0,ignited:1b}
execute if block 9 87 -342 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-342,distance=..3] run fill 8 86 -343 10 88 -341 air
execute if block 4 92 -356 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=4,y=92,z=-356,distance=..3] run tag @e[tag=mine,tag=part1] add target3
execute if block 4 92 -356 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=4,y=92,z=-356,distance=..3] run summon creeper 4 92 -356 {powered:1b,Fuse:0,ignited:1b}
execute if block 4 92 -356 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=4,y=92,z=-356,distance=..3] run fill 3 91 -357 5 93 -355 air
execute if block 9 87 -370 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-370,distance=..3] run tag @e[tag=mine,tag=part1] add target4
execute if block 9 87 -370 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-370,distance=..3] run summon creeper 9 87 -370 {powered:1b,Fuse:0,ignited:1b}
execute if block 9 87 -370 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=9,y=87,z=-370,distance=..3] run fill 8 86 -371 10 88 -369 air
execute if block 21 88 -372 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-372,distance=..3] run tag @e[tag=mine,tag=part1] add target5
execute if block 21 88 -372 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-372,distance=..3] run summon creeper 21 88 -372 {powered:1b,Fuse:0,ignited:1b}
execute if block 21 88 -372 target if entity @e[tag=mine,tag=part1] if entity @e[type=fireball,tag=fb,x=21,y=88,z=-372,distance=..3] run fill 20 87 -373 22 89 -371 air
execute as @e[tag=mine,tag=part1,tag=target1,tag=target2,tag=target3,tag=target4,tag=target5] run tag @s add part2
execute as @e[tag=mine,tag=part2,scores={minetimer=..1500}] run scoreboard players set @s minetimer 2000
execute as @e[tag=mine,tag=part2] run tag @s remove part1
execute as @e[tag=mine,tag=part2] run tp @e[type=blaze,x=-14,y=60,z=-397,dx=80,dy=60,dz=80] 0 -200 0
execute as @e[tag=mine,tag=part2] run tp @e[type=pillager,x=-14,y=60,z=-397,dx=80,dy=60,dz=80] 0 -200 0
execute as @e[tag=part2,scores={minetimer=2020}] run kill @e[tag=fb]
execute if entity @e[tag=part2,scores={minetimer=2020}] as @a at @a run playsound minecraft:entity.villager.no record @a ~ ~ ~ 1
execute as @e[tag=mine,tag=part2,scores={minetimer=2060}] run tp @a 18 162 -360
execute as @e[tag=mine,tag=part2,scores={minetimer=2060}] run spawnpoint @a 18 162 -360
execute as @e[tag=mine,tag=part2,scores={minetimer=2140}] run summon illusioner 18 162 -354 {CustomNameVisible:1b,DeathLootTable:"minecraft:empty",PersistenceRequired:1b,Health:80f,PatrolLeader:0b,Patrolling:0b,HasRaidGoal:1b,CanJoinRaid:0b,CustomName:'{"text":"Mining Foreman","color":"dark_aqua","bold":true}',HandItems:[{id:"minecraft:bow",Count:1b,tag:{Unbreakable:1b,CustomModelData:1,Enchantments:[{id:"minecraft:power",lvl:1s}]}},{}],HandDropChances:[-327.670F,0.085F],ArmorItems:[{},{},{},{id:"minecraft:apple",Count:1b,tag:{CustomModelData:10}}],ArmorDropChances:[0.085F,0.085F,0.085F,-327.670F],Attributes:[{Name:generic.max_health,Base:80}]}
execute as @e[tag=mine,tag=part2,scores={minetimer=2200..}] unless entity @e[type=illusioner,x=3,y=159,z=-374,dx=30,dy=20,dz=30] run tag @e[tag=mine] add part3
execute as @e[tag=mine,tag=part2,scores={minetimer=2200..}] if entity @e[type=illusioner,x=3,y=159,z=-374,dx=30,dy=20,dz=30] run scoreboard players set @e[tag=mine] minetimer 2300
execute as @e[tag=part3,scores={minetimer=2320}] run tag @a remove music_boss
execute as @e[tag=part3,scores={minetimer=2320}] run scoreboard players set @a musictimer_boss 0
execute as @e[tag=part3,scores={minetimer=2320}] run stopsound @a * minecraft:custom.storytime.boss
execute as @e[tag=part3,scores={minetimer=2400}] run tp @a 57 43 -139
execute as @e[tag=part3,scores={minetimer=2400}] run spawnpoint @a 57 43 -139
execute as @e[tag=part3,scores={minetimer=2400}] unless entity @a[tag=keepinv] run gamerule keepInventory false
execute as @e[tag=part3,scores={minetimer=2400}] run gamerule mobGriefing true
execute as @e[tag=part3,scores={minetimer=2400}] run gamemode survival @a
execute as @e[tag=part3,scores={minetimer=2460}] run tag @a add music_mine
execute as @e[tag=part3,scores={minetimer=2460}] run summon firework_rocket 57 43.9 -136 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:0,Colors:[I;16711680,65535,65280,16776960,16711935,16755200]}]}}}}
execute as @e[tag=part3,scores={minetimer=2460}] run summon item 57 44.5 -136 {Item:{id:"minecraft:book",Count:1b,tag:{display:{Name:'{"text":"Brokeback Mountain II: Too Broke To Back","color":"white","bold":true,"italic":false,"underlined":true}',Lore:['{"text":"Usually, ass is a synonym for","color":"gray"}','{"text":"donkey. In this book, it ain\'t.","color":"gray"}','{"text":"by D. Good, D. Bad & D. Ugly","color":"gray","italic":false}']},book:2,Enchantments:[{}]}}}
execute as @e[tag=part3,scores={minetimer=2461}] run kill @s
execute as @e[tag=mine] run effect give @e[scores={bossdeath=1}] weakness 10 1 true
execute as @e[tag=mine] run effect give @e[scores={bossdeath=1}] slowness 10 1 true
execute as @e[tag=mine] run scoreboard players set @e[scores={bossdeath=1},nbt={ActiveEffects:[{Id:2b}]},nbt={ActiveEffects:[{Id:18b}]}] bossdeath 0

# Space Boss
scoreboard players add @e[tag=space] spacetimer 1
scoreboard players add @e[tag=tempspace] tempspace 1
scoreboard players add @e[tag=drop] drop 1
execute as @e[type=silverfish,tag=egg,nbt={OnGround:1b}] run kill @s
execute as @e[tag=space] run kill @e[type=item,name="Powered Rail"]
execute as @a[x=-497,y=125,z=54,distance=..120] run effect give @s slow_falling 1 1 true
execute as @a[x=-497,y=125,z=54,distance=..120] run effect give @s jump_boost 1 3 true
execute as @e[x=-615,y=5,z=-71,dx=250,dy=70,dz=250] run kill @s
execute if block 1379 165 821 polished_blackstone_button[powered=true] run tag @a[limit=1] add tempspace
execute if block 1379 165 821 polished_blackstone_button[powered=true] run setblock 1379 165 821 air
execute as @e[scores={tempspace=1}] run spawnpoint @a -497 126 54
execute as @e[scores={tempspace=1}] run tag @a remove music_space
execute as @e[scores={tempspace=1}] run scoreboard players set @a musictimer_space 0
execute as @e[scores={tempspace=1}] run stopsound @a * minecraft:custom.storytime.space
execute as @e[scores={tempspace=20}] run effect give @a blindness 3 1 true
execute as @e[scores={tempspace=35}] run tp @a -497 180 54
execute as @e[scores={tempspace=40}] run tag @a add music_boss
execute as @e[scores={tempspace=60}] run summon armor_stand -512 140 54 {Invulnerable:1b,Invisible:1b,PersistenceRequired:1b,Tags:["space"]}
execute as @e[scores={tempspace=70}] run scoreboard players set @e[tag=space] spacetimer 60
execute as @e[scores={tempspace=80}] run tag @a remove tempspace
execute as @e[scores={tempspace=80}] run scoreboard players set @a tempspace 0
execute as @e[scores={spacetimer=60}] run gamemode adventure @a 
execute as @e[scores={spacetimer=60}] run gamerule keepInventory true
execute as @e[scores={spacetimer=60}] run gamerule mobGriefing false
execute as @e[scores={spacetimer=360}] run clone -426 225 51 -412 240 65 -504 149 47
execute as @e[scores={spacetimer=360}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[scores={spacetimer=380}] run tag @s add drop
execute as @e[tag=drop] run function 14er:spaceboss
execute as @e[tag=drop,tag=wave3,tag=!wave4] if block -497 158 54 powered_rail[powered=true] run tag @s add wave4
execute as @e[tag=drop,tag=wave2,tag=!wave3] if block -497 158 54 powered_rail[powered=true] run tag @s add wave3
execute as @e[tag=drop,tag=wave1,tag=!wave2] if block -497 158 54 powered_rail[powered=true] run tag @s add wave2
execute as @e[tag=drop,tag=!wave1] if block -497 158 54 powered_rail[powered=true] run tag @s add wave1
execute as @e[tag=drop] if block -497 158 54 powered_rail[powered=true] run scoreboard players set @e[tag=space] spacetimer 1000
execute as @e[tag=drop] if block -497 158 54 powered_rail[powered=true] run setblock -497 157 54 air
execute as @e[tag=drop,scores={drop=60..}] unless block -497 157 54 target run tag @s remove drop
execute as @e[tag=wave1,tag=!wave2,scores={spacetimer=1060}] run function 14er:spaceboss
execute as @e[tag=wave1,tag=!wave2,scores={spacetimer=1100}] run fill -504 149 47 -490 164 61 air
execute as @e[tag=wave1,tag=!wave2,scores={spacetimer=1100}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave1,tag=!wave2,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=stray,x=-497,y=125,z=54,distance=..18] run tag @s add mob1
execute as @e[tag=wave1,tag=!wave2,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=piglin_brute,x=-497,y=125,z=54,distance=..18] run tag @s add mob2
execute as @e[tag=mob1,tag=mob2] run setblock -510 141 54 blue_stained_glass
execute as @e[tag=mob1,tag=mob2] run summon firework_rocket -509 141 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=mob1,tag=mob2] run scoreboard players set @s drop 0
execute as @e[tag=mob1,tag=mob2] run tag @s add drop
execute as @e[tag=drop,tag=mob2] run tag @s remove mob1
execute as @e[tag=drop,tag=mob2] run tag @s remove mob2
execute as @e[tag=drop,tag=wave1,tag=!wave2,scores={drop=40}] run clone -426 225 51 -412 240 65 -504 149 47
execute as @e[tag=drop,tag=wave1,tag=!wave2,scores={drop=40}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave2,tag=!wave3,scores={spacetimer=1060}] run function 14er:spaceboss
execute as @e[tag=wave2,tag=!wave3,scores={spacetimer=1100}] run fill -504 149 47 -490 164 61 air
execute as @e[tag=wave2,tag=!wave3,scores={spacetimer=1100}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave2,tag=!wave3,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=stray,x=-497,y=125,z=54,distance=..18] run tag @s add mob3
execute as @e[tag=wave2,tag=!wave3,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=piglin_brute,x=-497,y=125,z=54,distance=..18] run tag @s add mob4
execute as @e[tag=wave2,tag=!wave3,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=piglin,x=-497,y=125,z=54,distance=..18] run tag @s add mob5
execute as @e[tag=mob3,tag=mob4,tag=mob5] run setblock -497 141 41 minecraft:blue_stained_glass
execute as @e[tag=mob3,tag=mob4,tag=mob5] run summon firework_rocket -497 141 42 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=mob3,tag=mob4,tag=mob5] run scoreboard players set @s drop 0
execute as @e[tag=mob3,tag=mob4,tag=mob5] run tag @s add drop
execute as @e[tag=drop,tag=mob5] run tag @s remove mob3
execute as @e[tag=drop,tag=mob5] run tag @s remove mob4
execute as @e[tag=drop,tag=mob5] run tag @s remove mob5
execute as @e[tag=drop,tag=wave2,tag=!wave3,scores={drop=40}] run clone -426 225 51 -412 240 65 -504 149 47
execute as @e[tag=drop,tag=wave2,tag=!wave3,scores={drop=40}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave3,tag=!wave4,scores={spacetimer=1060}] run function 14er:spaceboss
execute as @e[tag=wave3,tag=!wave4,scores={spacetimer=1100}] run fill -504 149 47 -490 164 61 air
execute as @e[tag=wave3,tag=!wave4,scores={spacetimer=1100}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave3,tag=!wave4,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=piglin_brute,x=-497,y=125,z=54,distance=..18] run tag @s add mob6
execute as @e[tag=wave3,tag=!wave4,tag=!drop,scores={spacetimer=1100..}] unless entity @e[type=piglin,x=-497,y=125,z=54,distance=..18] run tag @s add mob7
execute as @e[tag=mob6,tag=mob7] run setblock -484 141 54 minecraft:blue_stained_glass
execute as @e[tag=mob6,tag=mob7] run summon firework_rocket -485 141 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=mob6,tag=mob7] run scoreboard players set @s drop 0
execute as @e[tag=mob6,tag=mob7] run tag @s add drop
execute as @e[tag=drop,tag=mob7] run tag @s remove mob6
execute as @e[tag=drop,tag=mob7] run tag @s remove mob7
execute as @e[tag=drop,tag=wave3,tag=!wave4,scores={drop=40}] run clone -426 225 51 -412 240 65 -504 149 47
execute as @e[tag=drop,tag=wave3,tag=!wave4,scores={drop=40}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave4,scores={spacetimer=1060}] run function 14er:spaceboss
execute as @e[tag=wave4,scores={spacetimer=1100}] run fill -504 149 47 -490 164 61 air
execute as @e[tag=wave4,scores={spacetimer=1100}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=wave4,tag=!endwave,tag=!endspace,scores={spacetimer=1100..}] unless entity @e[type=piglin_brute,x=-497,y=125,z=54,distance=..18] run tag @s add mob8
execute as @e[tag=wave4,tag=!endwave,tag=!endspace,scores={spacetimer=1100..}] unless entity @e[type=hoglin,x=-497,y=125,z=54,distance=..18] run tag @s add mob9
execute as @e[tag=mob8,tag=mob9] run setblock -497 141 67 minecraft:blue_stained_glass
execute as @e[tag=mob8,tag=mob9] run summon firework_rocket -497 141 66 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]}]}}}}
execute as @e[tag=mob8,tag=mob9] run scoreboard players set @s spacetimer 2000
execute as @e[tag=mob8,tag=mob9] run tag @s add endwave
execute as @e[tag=endwave,tag=mob9] run tag @s remove mob8
execute as @e[tag=endwave,tag=mob9] run tag @s remove mob9
execute as @e[tag=endwave,scores={spacetimer=2060}] run clone -426 225 69 -412 240 83 -504 149 47
execute as @e[tag=endwave,scores={spacetimer=2060}] run summon firework_rocket -497 152 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]},{Type:1,Colors:[I;65535]}]}}}}
execute if entity @e[tag=endwave,scores={spacetimer=2120}] as @a at @a run playsound minecraft:block.beacon.activate record @a ~ ~ ~ 1
execute as @e[tag=endwave,scores={spacetimer=2120..2430}] run particle flash -482 147.2 54 0.1 0.1 0.1 0 1 force
execute as @e[tag=endwave,scores={spacetimer=2120..2430}] run particle flash -497 147.2 69 0.1 0.1 0.1 0 1 force
execute as @e[tag=endwave,scores={spacetimer=2120..2430}] run particle flash -512 147.2 54 0.1 0.1 0.1 0 1 force
execute as @e[tag=endwave,scores={spacetimer=2120..2430}] run particle flash -497 147.2 39 0.1 0.1 0.1 0 1 force
execute if entity @e[tag=endwave,scores={spacetimer=2220..2430}] as @a at @a run playsound minecraft:entity.guardian.attack record @a ~ ~ ~ 1
execute as @e[tag=endwave,scores={spacetimer=2220..2430}] run summon snowball -482 147.2 54 {Motion:[-1.0,1.0,0.0],Item:{id:"minecraft:sea_lantern",Count:1b}}
execute as @e[tag=endwave,scores={spacetimer=2220..2430}] run summon snowball -512 147.2 54 {Motion:[1.0,1.0,0.0],Item:{id:"minecraft:sea_lantern",Count:1b}}
execute as @e[tag=endwave,scores={spacetimer=2220..2430}] run summon snowball -497 147.2 39 {Motion:[0.0,1.0,1.0],Item:{id:"minecraft:sea_lantern",Count:1b}}
execute as @e[tag=endwave,scores={spacetimer=2220..2430}] run summon snowball -497 147.2 69 {Motion:[0.0,1.0,-1.0],Item:{id:"minecraft:sea_lantern",Count:1b}}
execute as @e[tag=endwave,scores={spacetimer=2220..2430}] at @e[type=snowball] run particle minecraft:end_rod ~ ~ ~ 0.1 0.1 0.1 0.1 1 force
execute as @e[tag=endwave,scores={spacetimer=2320}] run summon creeper -493 154 56 {ExplosionRadius:5b,Fuse:0}
execute as @e[tag=endwave,scores={spacetimer=2340}] run summon creeper -496 154 49 {ExplosionRadius:5b,Fuse:0}
execute as @e[tag=endwave,scores={spacetimer=2360}] run summon creeper -502 154 54 {ExplosionRadius:5b,Fuse:0}
execute as @e[tag=endwave,scores={spacetimer=2420}] run function 14er:spaceboss
execute as @e[tag=endwave,scores={spacetimer=2430}] run fill -504 149 47 -490 164 61 air
execute as @e[tag=endwave,scores={spacetimer=2500}] run summon silverfish -497 150 54 {Silent:1b,Invulnerable:1b,PersistenceRequired:1b,Tags:["egg"],Passengers:[{id:"minecraft:falling_block",BlockState:{Name:"minecraft:dragon_egg"},Time:1,DropItem:0b}],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b},{Id:28b,Amplifier:1b,Duration:1999980,ShowParticles:0b}]}
execute as @e[tag=endwave,scores={spacetimer=2660}] run fill -512 126 39 -482 126 69 air replace dragon_egg
execute as @e[tag=endwave,scores={spacetimer=2660}] run summon firework_rocket -497 126.1 54 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:4,Colors:[I;16711935,10027263]}]}}}}
execute as @e[tag=endwave,scores={spacetimer=2660}] run summon hoglin -497 126 54 {CustomNameVisible:1b,Team:"boss",DeathLootTable:"minecraft:empty",Health:64f,IsImmuneToZombification:1b,CannotBeHunted:1b,Passengers:[{id:"minecraft:armor_stand",CustomNameVisible:0b,Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,PersistenceRequired:1b,ArmorItems:[{},{},{},{id:'minecraft:apple',Count:1b,tag:{CustomModelData:14}}],CustomName:'{"text":"model"}'},{id:"minecraft:piglin",CustomNameVisible:1b,Team:"boss",DeathLootTable:"minecraft:empty",Health:64f,IsBaby:0b,IsImmuneToZombification:1b,CannotHunt:1b,CustomName:'{"text":"Space Boss","color":"red","bold":true}',HandItems:[{id:"minecraft:crossbow",Count:1b,tag:{CustomModelData:2,Enchantments:[{id:"minecraft:quick_charge",lvl:3s}]}},{}],HandDropChances:[-327.670F,0.085F],Attributes:[{Name:generic.max_health,Base:64}]}],CustomName:'{"text":"Space Boss","color":"red","bold":true}',ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1999980,ShowParticles:0b}],Attributes:[{Name:generic.max_health,Base:64},{Name:generic.movement_speed,Base:0.15},{Name:generic.attack_damage,Base:6}]}
execute as @e[tag=endwave,scores={spacetimer=2700..}] unless entity @e[type=piglin,x=-497,y=125,z=54,distance=..18] run tag @s add boss1
execute as @e[tag=endwave,scores={spacetimer=2700..}] unless entity @e[type=hoglin,x=-497,y=125,z=54,distance=..18] run tag @s add boss2
execute as @e[tag=boss1,tag=boss2] run tag @s add endspace
execute as @e[tag=boss1,tag=boss2] run tag @s remove endwave
execute as @e[tag=boss1,tag=boss2] run scoreboard players set @s spacetimer 3000
execute as @e[tag=endspace,tag=boss2] run tag @s remove boss1
execute as @e[tag=endspace,tag=boss2] run tag @s remove boss2
execute as @e[tag=endspace,scores={spacetimer=3020}] run tag @a remove music_boss
execute as @e[tag=endspace,scores={spacetimer=3020}] run scoreboard players set @a musictimer_boss 0
execute as @e[tag=endspace,scores={spacetimer=3020}] run stopsound @a * minecraft:custom.storytime.boss
execute as @e[tag=endspace,scores={spacetimer=3060}] run tp @s -140 137 129
execute as @e[tag=endspace,scores={spacetimer=3100}] run tp @a 1382 163 821
execute as @e[tag=endspace,scores={spacetimer=3100}] run spawnpoint @a 1382 163 821
execute as @e[tag=endspace,scores={spacetimer=3100}] unless entity @a[tag=keepinv] run gamerule keepInventory false
execute as @e[tag=endspace,scores={spacetimer=3100}] run gamerule mobGriefing true
execute as @e[tag=endspace,scores={spacetimer=3100}] run gamemode survival @a
execute as @e[tag=endspace,scores={spacetimer=3160}] run tag @a add music_space
execute as @e[tag=endspace,scores={spacetimer=3160}] run summon firework_rocket 1379 163.9 821 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:0,Colors:[I;16711680,65535,65280,16776960,16711935,16755200]}]}}}}
execute as @e[tag=endspace,scores={spacetimer=3160}] run summon item 1379 165 821 {Item:{id:"minecraft:book",Count:1b,tag:{display:{Name:'{"text":"War Stars: The Forcefully Woken","color":"white","bold":true,"italic":false,"underlined":true}',Lore:['{"text":"Legally distinct.","color":"gray"}','{"text":"by Meorge S. S. Gartin","color":"gray","italic":false}']},book:3,Enchantments:[{}]}}}
execute as @e[tag=endspace,scores={spacetimer=3180}] run kill @s
execute as @e[tag=space] run effect give @e[scores={bossdeath=1}] weakness 10 1 true
execute as @e[tag=space] run effect give @e[scores={bossdeath=1}] slowness 10 1 true
execute as @e[tag=space] run scoreboard players set @e[scores={bossdeath=1},nbt={ActiveEffects:[{Id:2b}]},nbt={ActiveEffects:[{Id:18b}]}] bossdeath 0
